//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ CG-ROM ]
//
//	CG-ROM̍ASÝAJĂWinX68k̃\[XQlɂĂ܂B
//	  ASYlāE쐬ꂽA񂶂厁E䂢Ɋӂ܂B
//
//---------------------------------------------------------------------------

#if !defined(cgrom_h)
#define cgrom_h

#include "filepath.h"

//===========================================================================
//
//	CG-ROM
//
//===========================================================================
class CGROM
{
public:
	enum FontSize {
		Size6x12,						// 6x12tHg
		Size8x16,						// 8x16tHg
		Size6x24,						// 6x24tHg
		Size12x24,						// 12x24tHg
		SizeMax
	};

public:
	// {t@NV
	CGROM();
										// RXgN^
	virtual ~CGROM();
										// fXgN^

	// OAPI
	BOOL FASTCALL Init();
										// 
	void FASTCALL Cleanup();
										// N[Abv
	BOOL FASTCALL Create(Filepath& path, DWORD dwVer);
										// 쐬

	// tHgL̔f
	static int CALLBACK EnumFontFamExCb(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme,
		DWORD FontType, LPARAM lParam);	// EnumFontFamiliesExR[obN
	TCHAR m_szGothicName[LF_FACESIZE];
										// SVbNtHg
	TCHAR m_szMinchoName[LF_FACESIZE];
										// tHg

private:
	// tHgL̔f
	BOOL FASTCALL IsInstalled();
										// tHgCXg[Ă邩

	// foCXReLXgErbg}bvEtHg
	void FASTCALL InitLogFont(int nSize, LOGFONT *lf, LPCTSTR lpszFontName);
										// LOGFONT
	HDC m_hDC;
										// DC
	HBITMAP m_hDIBitmap;
										// rbg}bv(DIBZNV)
	HBITMAP m_hBitmapBk;
										// rbg}bv(obNAbv)
	HFONT m_hFontBk;
										// tHg(obNAbv)
	HFONT m_hGothic[SizeMax];
										// SVbNtHg
	HFONT m_hMincho[SizeMax];
										// tHg
	BYTE *m_pBits;
										// rbgf[^̈(GDIm)

	// 쐬C
	void FASTCALL Create8x8();
										// 쐬 (8x8)
	void FASTCALL Create8x16();
										// 쐬 (8x16)
	void FASTCALL Create12x12();
										// 쐬 (12x12)
	void FASTCALL Create12x24();
										// 쐬 (12x24)
	void FASTCALL Create16x16();
										// 쐬 (16x16)
	void FASTCALL Create24x24();
										// 쐬 (24x24)
	void FASTCALL CreateVer(DWORD dwVer);
										// 쐬 (o[W)

	// 쐬Tu
	void FASTCALL GetFontStr(BOOL bGothic, BOOL bZenkaku, LPCTSTR lpszText, int nSize);
										// w肵񂩂AtHg擾
	void FASTCALL GetFontGen(BOOL bGothic, DWORD dwBase, int nSize);
										// 쐬ŁAtHg擾
	int FASTCALL CopyFromBits(BYTE *pDest, BOOL bZenkaku, int nSize);
										// DIBobt@e|obt@֓]
	WORD FASTCALL Jis2ShiftJis(WORD wJis);
										// JISSHIFT-JISϊ

	// obt@
	BYTE *m_pBuf;
										// ROMf[^obt@
	BYTE *m_pTemp;
										// e|obt@

	// tHgf[^Ee[uf[^
	static const BYTE Font8x8[0x7e8];
										// tHg(8x8)
	static const WORD Font8x16[0x2c8];
										// tHg(8x16)
	static const WORD Font12x12[0x198];
										// tHg(12x12)
	static const WORD Font12x24[0x330];
										// tHg(12x24)
	static const WORD Font16x16[0x200];
										// tHg(16x16)
	static const WORD Font24x24[0x480];
										// tHg(24x24)
	static LPCTSTR HankakuTable[14];
										// pe[u
	static const int ExceptTable[36];
										// SpOe[u
};

#endif	// cgrom_h
