//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ MFC ]
//
//---------------------------------------------------------------------------

#if defined(_WIN32)

#if !defined(mfc_h)
#define mfc_h

//---------------------------------------------------------------------------
//
//	#include
//
//---------------------------------------------------------------------------
#define WINVER					0x501
#define _WIN32_WINNT			0x501
#define VC_EXTRALEAN

// MFC
#include <afxwin.h>

// C Runtime
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>

//---------------------------------------------------------------------------
//
//	#define
//
//---------------------------------------------------------------------------
#if defined(_DEBUG)
#define new		DEBUG_NEW
#endif	// _DEBUG

#if defined(_MSC_VER) && defined(_M_IX86)
#define FASTCALL	__fastcall
#else
#define FASTCALL
#endif	// _MSC_VER

//---------------------------------------------------------------------------
//
//	NX錾
//
//---------------------------------------------------------------------------
class CUtilApp;
										// AvP[V
class CUtilDlg;
										// C_CAO

//---------------------------------------------------------------------------
//
//	O[o
//
//---------------------------------------------------------------------------
BOOL FASTCALL IsJapanese(void);
										// {̔
BOOL FASTCALL IsWinNT(void);
										// WindowsNT̔
BOOL FASTCALL Support932(void);
										// CP932T|[gL̔
void FASTCALL GetMsg(UINT uID, CString& string);
										// bZ[W擾
int FASTCALL DrawTextWide(HDC hDC, LPCWSTR lpString, int nCount, LPRECT lpRect, UINT uFormat);
										// DrawTextWbp

#endif	// mfc_h
#endif	// _WIN32
