//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ SCSI-ROM ]
//
//---------------------------------------------------------------------------

#if !defined(truekey_h)
#define scsirom_h

#include "filepath.h"
#include "fatfs.h"

//===========================================================================
//
//	SCSI-ROM
//
//===========================================================================
class SCSIROM
{
public:
public:
	// {t@NV
	SCSIROM();
										// RXgN^
	virtual ~SCSIROM();
										// fXgN^

	// OAPI
	BOOL FASTCALL Init();
										// 
	void FASTCALL Cleanup();
										// N[Abv

	// 쐬
	BOOL FASTCALL Create(BOOL exrom, DWORD ver);
										// 쐬

private:
	// Tu[`
	void FASTCALL AddLong(DWORD add, BYTE *ptr);
										// LongZ

	// IuWFNg
	FATFs *fs;
										// t@CVXe

	// [N
	BYTE ROM[0x2000];
										// ROMC[W
	BYTE FORMAT[0x20000];
										// FORMAT.xC[W

	// f[^
	static const BYTE SCSIIN[864];
										// SCSIN(SCSIIN)
	static const BYTE SCSIEX[898];
										// SCSIN(SCSIEX)
};

#endif	// scsirom_h
