//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ TrueKey ]
//
//---------------------------------------------------------------------------

#if !defined(truekey_h)
#define truekey_h

//===========================================================================
//
//	TrueKey
//
//===========================================================================
class TrueKey
{
public:
	// 萔
	enum {
		BitmapMax = 0x10000				// rbg}bvőTCY
	};

public:
	// {t@NV
	TrueKey();
										// RXgN^
	virtual ~TrueKey();
										// fXgN^

	// OAPI
	BOOL FASTCALL Init();
										// 
	void FASTCALL Cleanup();
										// N[Abv

	// rbg}bv
	int FASTCALL GetWidth() const;
										// 擾
	int FASTCALL GetHeight() const;
										// 擾
	int FASTCALL GetBitCount() const;
										// rbg擾
	const BYTE* FASTCALL GetBits() const;
										// rbgf[^擾

private:
	// WJ
	DWORD FASTCALL Extract(const BYTE *pSrc, BYTE *pDst, DWORD dwLength);
										// WJ
	BOOL FASTCALL IsValid() const;
										// Ó`FbN

	// [N()
	BYTE *m_pBuf;
										// WJobt@
	DWORD m_dwSize;
										// WJ̃TCY

	// [N(WJ)
	BYTE m_byDic[0x1000];
										// 

	// f[^
	static const BYTE CompressData[11258];
										// kf[^(LZP`)
};

#endif	// truekey_h
